Index: serefpolicy-contrib-20140730/rpcbind.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rpcbind.if
+++ serefpolicy-contrib-20140730/rpcbind.if
@@ -1,4 +1,4 @@
-## <summary>Universal Addresses to RPC Program Number Mapper.</summary>
+## <summary>Universal Addresses to RPC Program Number Mapper</summary>
 
 ########################################
 ## <summary>
@@ -15,14 +15,12 @@ interface(`rpcbind_domtrans',`
 		type rpcbind_t, rpcbind_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, rpcbind_exec_t, rpcbind_t)
 ')
 
 ########################################
 ## <summary>
-##	Connect to rpcbindd with a
-##	unix domain stream socket.
+##	Connect to rpcbindd over an unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -41,7 +39,7 @@ interface(`rpcbind_stream_connect',`
 
 ########################################
 ## <summary>
-##	Read rpcbind pid files.
+##	Read rpcbind PID files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -73,8 +71,8 @@ interface(`rpcbind_search_lib',`
 		type rpcbind_var_lib_t;
 	')
 
-	files_search_var_lib($1)
 	allow $1 rpcbind_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
 ')
 
 ########################################
@@ -92,8 +90,8 @@ interface(`rpcbind_read_lib_files',`
 		type rpcbind_var_lib_t;
 	')
 
-	files_search_var_lib($1)
 	read_files_pattern($1, rpcbind_var_lib_t, rpcbind_var_lib_t)
+	files_search_var_lib($1)
 ')
 
 ########################################
@@ -112,13 +110,13 @@ interface(`rpcbind_manage_lib_files',`
 		type rpcbind_var_lib_t;
 	')
 
-	files_search_var_lib($1)
 	manage_files_pattern($1, rpcbind_var_lib_t, rpcbind_var_lib_t)
+	files_search_var_lib($1)
 ')
 
 ########################################
 ## <summary>
-##	Send null signals to rpcbind.
+##	Send a null signal to rpcbind.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -136,8 +134,44 @@ interface(`rpcbind_signull',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an rpcbind environment.
+##	Transition to rpcbind named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rpcbind_filetrans_named_content',`
+	gen_require(`
+		type rpcbind_var_run_t;
+	')
+
+	files_pid_filetrans($1, rpcbind_var_run_t, sock_file, "rpcbind.sock")
+')
+
+########################################
+## <summary>
+##	Relabel from rpcbind sock file.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`rpcbind_relabel_sock_file',`
+	gen_require(`
+		type rpcbind_var_run_t;
+	')
+
+	allow $1 rpcbind_var_run_t:sock_file relabel_sock_file_perms;
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an rpcbind environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -146,7 +180,7 @@ interface(`rpcbind_signull',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the rpcbind domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -157,17 +191,20 @@ interface(`rpcbind_admin',`
 		type rpcbind_initrc_exec_t;
 	')
 
-	allow $1 rpcbind_t:process { ptrace signal_perms };
+	allow $1 rpcbind_t:process signal_perms;
 	ps_process_pattern($1, rpcbind_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 rpcbind_t:process ptrace;
+	')
 
-	init_labeled_script_domtrans($1, rbcbind_initrc_exec_t)
+	init_labeled_script_domtrans($1, rpcbind_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 rpcbind_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_pids($1)
-	admin_pattern($1, rpcbind_var_run_t)
-
-	files_search_var_lib($1)
+	files_list_var_lib($1)
 	admin_pattern($1, rpcbind_var_lib_t)
+
+	files_list_pids($1)
+	admin_pattern($1, rpcbind_var_run_t)
 ')
Index: serefpolicy-contrib-20140730/rpcbind.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rpcbind.te
+++ serefpolicy-contrib-20140730/rpcbind.te
@@ -1,4 +1,4 @@
-policy_module(rpcbind, 1.7.1)
+policy_module(rpcbind, 1.6.1)
 
 ########################################
 #
@@ -14,7 +14,7 @@ init_script_file(rpcbind_initrc_exec_t)
 
 type rpcbind_var_run_t;
 files_pid_file(rpcbind_var_run_t)
-init_daemon_pid_file(rpcbind_var_run_t, dir, "rpcbind")
+init_daemon_run_dir(rpcbind_var_run_t, "rpcbind")
 
 type rpcbind_var_lib_t;
 files_type(rpcbind_var_lib_t)
@@ -42,7 +42,6 @@ kernel_read_system_state(rpcbind_t)
 kernel_read_network_state(rpcbind_t)
 kernel_request_load_module(rpcbind_t)
 
-corenet_all_recvfrom_unlabeled(rpcbind_t)
 corenet_all_recvfrom_netlabel(rpcbind_t)
 corenet_tcp_sendrecv_generic_if(rpcbind_t)
 corenet_udp_sendrecv_generic_if(rpcbind_t)
@@ -68,7 +67,11 @@ auth_use_nsswitch(rpcbind_t)
 
 logging_send_syslog_msg(rpcbind_t)
 
-miscfiles_read_localization(rpcbind_t)
+sysnet_dns_name_resolve(rpcbind_t)
+
+optional_policy(`
+	nis_use_ypbind(rpcbind_t)
+')
 
 ifdef(`distro_debian',`
 	term_dontaudit_use_unallocated_ttys(rpcbind_t)
Index: serefpolicy-contrib-20140730/rpc.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/rpc.fc
+++ serefpolicy-contrib-20140730/rpc.fc
@@ -1,12 +1,23 @@
-/etc/exports	--	gen_context(system_u:object_r:exports_t,s0)
+#
+# /etc
+#
+/etc/exports		--	gen_context(system_u:object_r:exports_t,s0)
+/etc/rc\.d/init\.d/nfs	 --	gen_context(system_u:object_r:nfsd_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/nfslock --	gen_context(system_u:object_r:rpcd_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/rpcidmapd --	gen_context(system_u:object_r:rpcd_initrc_exec_t,s0)
 
-/etc/rc\.d/init\.d/nfs	--	gen_context(system_u:object_r:nfsd_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/nfslock	--	gen_context(system_u:object_r:rpcd_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/rpcidmapd	--	gen_context(system_u:object_r:rpcd_initrc_exec_t,s0)
+/usr/lib/systemd/system/nfs.* 		--	gen_context(system_u:object_r:nfsd_unit_file_t,s0)
+/usr/lib/systemd/system/rpc.* 		--	gen_context(system_u:object_r:rpcd_unit_file_t,s0)
 
-/sbin/rpc\..*	--	gen_context(system_u:object_r:rpcd_exec_t,s0)
-/sbin/sm-notify	--	gen_context(system_u:object_r:rpcd_exec_t,s0)
+#
+# /sbin
+#
+/sbin/rpc\..*		--	gen_context(system_u:object_r:rpcd_exec_t,s0)
+/sbin/sm-notify		--	gen_context(system_u:object_r:rpcd_exec_t,s0)
 
+#
+# /usr
+#
 /usr/sbin/rpc\..*	--	gen_context(system_u:object_r:rpcd_exec_t,s0)
 /usr/sbin/rpc\.idmapd	--	gen_context(system_u:object_r:rpcd_exec_t,s0)
 /usr/sbin/rpc\.gssd	--	gen_context(system_u:object_r:gssd_exec_t,s0)
@@ -16,7 +27,12 @@
 /usr/sbin/rpc\.svcgssd	--	gen_context(system_u:object_r:gssd_exec_t,s0)
 /usr/sbin/sm-notify	--	gen_context(system_u:object_r:rpcd_exec_t,s0)
 
-/var/lib/nfs(/.*)?	gen_context(system_u:object_r:var_lib_nfs_t,s0)
+#
+# /var
+#
+/var/lib/nfs(/.*)?		gen_context(system_u:object_r:var_lib_nfs_t,s0)
 
+/var/run/sm-notify.*		gen_context(system_u:object_r:rpcd_var_run_t,s0)
 /var/run/rpc\.statd(/.*)?	gen_context(system_u:object_r:rpcd_var_run_t,s0)
-/var/run/rpc\.statd\.pid	--	gen_context(system_u:object_r:rpcd_var_run_t,s0)
+/var/run/rpc\.statd\.pid --	gen_context(system_u:object_r:rpcd_var_run_t,s0)
+
Index: serefpolicy-contrib-20140730/rpc.if
===================================================================
--- serefpolicy-contrib-20140730.orig/rpc.if
+++ serefpolicy-contrib-20140730/rpc.if
@@ -1,4 +1,4 @@
-## <summary>Remote Procedure Call Daemon.</summary>
+## <summary>Remote Procedure Call Daemon for managment of network based process communication</summary>
 
 ########################################
 ## <summary>
@@ -20,15 +20,21 @@ interface(`rpc_stub',`
 ## <summary>
 ##	The template to define a rpc domain.
 ## </summary>
-## <param name="domain_prefix">
+## <desc>
+##	<p>
+##	This template creates a domain to be used for
+##	a new rpc daemon.
+##	</p>
+## </desc>
+## <param name="userdomain_prefix">
 ##	<summary>
-##	Domain prefix to be used.
+##	The type of daemon to be used.
 ##	</summary>
 ## </param>
 #
 template(`rpc_domain_template',`
 	gen_require(`
-		attribute rpc_domain;
+        attribute rpc_domain;
 	')
 
 	########################################
@@ -42,12 +48,19 @@ template(`rpc_domain_template',`
 
 	domain_use_interactive_fds($1_t)
 
-	########################################
+	####################################
 	#
-	# Policy
+	# Local Policy
 	#
 
+    kernel_read_system_state($1_t)
+
+    corenet_all_recvfrom_unlabeled($1_t)
+    corenet_all_recvfrom_netlabel($1_t)
+
 	auth_use_nsswitch($1_t)
+
+	logging_send_syslog_msg($1_t)
 ')
 
 ########################################
@@ -66,8 +79,8 @@ interface(`rpc_udp_send',`
 
 ########################################
 ## <summary>
-##	Do not audit attempts to get
-##	attributes of export files.
+##	Do not audit attempts to get the attributes
+##	of the NFS export file.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -80,12 +93,12 @@ interface(`rpc_dontaudit_getattr_exports
 		type exports_t;
 	')
 
-	dontaudit $1 exports_t:file getattr;
+	dontaudit $1 exports_t:file getattr_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read export files.
+##	Allow read access to exports.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -103,7 +116,7 @@ interface(`rpc_read_exports',`
 
 ########################################
 ## <summary>
-##	Write export files.
+##	Allow write access to exports.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -116,12 +129,12 @@ interface(`rpc_write_exports',`
 		type exports_t;
 	')
 
-	allow $1 exports_t:file write;
+	allow $1 exports_t:file write_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Execute nfsd in the nfsd domain.
+##	Execute domain in nfsd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -134,14 +147,12 @@ interface(`rpc_domtrans_nfsd',`
 		type nfsd_t, nfsd_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, nfsd_exec_t, nfsd_t)
 ')
 
 #######################################
 ## <summary>
-##	Execute nfsd init scripts in
-##	the initrc domain.
+##	Execute domain in nfsd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -159,7 +170,7 @@ interface(`rpc_initrc_domtrans_nfsd',`
 
 ########################################
 ## <summary>
-##	Execute rpcd in the rpcd domain.
+##	Execute nfsd server in the nfsd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -167,120 +178,126 @@ interface(`rpc_initrc_domtrans_nfsd',`
 ##	</summary>
 ## </param>
 #
-interface(`rpc_domtrans_rpcd',`
+interface(`rpc_systemctl_nfsd',`
 	gen_require(`
-		type rpcd_t, rpcd_exec_t;
+		type nfsd_unit_file_t;
+		type nfsd_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, rpcd_exec_t, rpcd_t)
+	systemd_exec_systemctl($1)
+	allow $1 nfsd_unit_file_t:file read_file_perms;
+	allow $1 nfsd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, nfsd_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Execute rpcd init scripts in
-##	the initrc domain.
+##	Send kill signals to rpcd.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`rpc_initrc_domtrans_rpcd',`
+interface(`rpc_kill_rpcd',`
 	gen_require(`
-		type rpcd_initrc_exec_t;
+		type rpcd_t;
 	')
 
-	init_labeled_script_domtrans($1, rpcd_initrc_exec_t)
+	allow $1 rpcd_t:process sigkill;
 ')
 
 ########################################
 ## <summary>
-##	Read nfs exported content.
+##	Execute domain in rpcd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`rpc_read_nfs_content',`
+interface(`rpc_domtrans_rpcd',`
 	gen_require(`
-		type nfsd_ro_t, nfsd_rw_t;
+		type rpcd_t, rpcd_exec_t;
 	')
 
-	allow $1 { nfsd_ro_t nfsd_rw_t }:dir list_dir_perms;
-	allow $1 { nfsd_ro_t nfsd_rw_t }:file read_file_perms;
-	allow $1 { nfsd_ro_t nfsd_rw_t }:lnk_file read_lnk_file_perms;
+	domtrans_pattern($1, rpcd_exec_t, rpcd_t)
+	allow rpcd_t $1:process signal;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	nfs exported read write content.
+##	Execute rpcd in the rcpd domain, and
+##	allow the specified role the rpcd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
+## <param name="role">
+##      <summary>
+##      Role allowed access.
+##      </summary>
+## </param>
 ## <rolecap/>
 #
-interface(`rpc_manage_nfs_rw_content',`
+interface(`rpc_run_rpcd',`
 	gen_require(`
-		type nfsd_rw_t;
+		type rpcd_t;
 	')
 
-	manage_dirs_pattern($1, nfsd_rw_t, nfsd_rw_t)
-	manage_files_pattern($1, nfsd_rw_t, nfsd_rw_t)
-	manage_lnk_files_pattern($1, nfsd_rw_t, nfsd_rw_t)
+	rpc_domtrans_rpcd($1)
+	role $2 types rpcd_t;
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Create, read, write, and delete
-##	nfs exported read only content.
+##	Execute domain in rpcd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
-interface(`rpc_manage_nfs_ro_content',`
+interface(`rpc_initrc_domtrans_rpcd',`
 	gen_require(`
-		type nfsd_ro_t;
+		type rpcd_initrc_exec_t;
 	')
 
-	manage_dirs_pattern($1, nfsd_ro_t, nfsd_ro_t)
-	manage_files_pattern($1, nfsd_ro_t, nfsd_ro_t)
-	manage_lnk_files_pattern($1, nfsd_ro_t, nfsd_ro_t)
+	init_labeled_script_domtrans($1, rpcd_initrc_exec_t)
 ')
 
 ########################################
 ## <summary>
-##	Read and write to nfsd tcp sockets.
+##	Execute rpcd server in the rpcd domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
 #
-interface(`rpc_tcp_rw_nfs_sockets',`
+interface(`rpc_systemctl_rpcd',`
 	gen_require(`
-		type nfsd_t;
+		type rpcd_unit_file_t;
+		type rpcd_t;
 	')
 
-	allow $1 nfsd_t:tcp_socket rw_socket_perms;
+	systemd_exec_systemctl($1)
+	allow $1 rpcd_unit_file_t:file read_file_perms;
+	allow $1 rpcd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, rpcd_t)
 ')
 
 ########################################
 ## <summary>
-##	Read and write to nfsd udp sockets.
+##	Allow domain to read and write to an NFS UDP socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -312,7 +329,7 @@ interface(`rpc_udp_send_nfs',`
 
 ########################################
 ## <summary>
-##	Search nfs lib directories.
+##	Search NFS state data in /var/lib/nfs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -326,12 +343,12 @@ interface(`rpc_search_nfs_state_data',`
 	')
 
 	files_search_var_lib($1)
-	allow $1 var_lib_nfs_t:dir search;
+	allow $1 var_lib_nfs_t:dir search_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read nfs lib files.
+##	List NFS state data in /var/lib/nfs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -339,19 +356,18 @@ interface(`rpc_search_nfs_state_data',`
 ##	</summary>
 ## </param>
 #
-interface(`rpc_read_nfs_state_data',`
+interface(`rpc_list_nfs_state_data',`
 	gen_require(`
 		type var_lib_nfs_t;
 	')
 
 	files_search_var_lib($1)
-	read_files_pattern($1, var_lib_nfs_t, var_lib_nfs_t)
+	allow $1 var_lib_nfs_t:dir list_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	nfs lib files.
+##	Read NFS state data in /var/lib/nfs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -359,34 +375,54 @@ interface(`rpc_read_nfs_state_data',`
 ##	</summary>
 ## </param>
 #
-interface(`rpc_manage_nfs_state_data',`
+interface(`rpc_read_nfs_state_data',`
 	gen_require(`
 		type var_lib_nfs_t;
 	')
 
 	files_search_var_lib($1)
-	manage_files_pattern($1, var_lib_nfs_t, var_lib_nfs_t)
+	read_files_pattern($1, var_lib_nfs_t, var_lib_nfs_t)
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an rpc environment.
+##	Manage NFS state data in /var/lib/nfs.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
+#
+interface(`rpc_manage_nfs_state_data',`
+	gen_require(`
+		type var_lib_nfs_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, var_lib_nfs_t, var_lib_nfs_t)
+	allow $1 var_lib_nfs_t:file relabel_file_perms;
+')
+
+#######################################
+## <summary>
+##  All of the rules required to
+##  administrate an rpc environment.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
 ## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
+##  <summary>
+##  Role allowed access.
+##  </summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`rpc_admin',`
-	gen_require(`
+    gen_require(`
 		attribute rpc_domain;
 		type nfsd_initrc_exec_t, rpcd_initrc_exec_t, exports_t;
 		type var_lib_nfs_t, rpcd_var_run_t, gssd_tmp_t;
Index: serefpolicy-contrib-20140730/rpc.te
===================================================================
--- serefpolicy-contrib-20140730.orig/rpc.te
+++ serefpolicy-contrib-20140730/rpc.te
@@ -1,4 +1,4 @@
-policy_module(rpc, 1.16.0)
+policy_module(rpc, 1.15.1)
 
 ########################################
 #
@@ -6,22 +6,20 @@ policy_module(rpc, 1.16.0)
 #
 
 ## <desc>
-##	<p>
-##	Determine whether gssd can read
-##	generic user temporary content.
-##	</p>
+## <p>
+## Allow gssd to list tmp directories and read the kerberos credential cache.
+## </p>
 ## </desc>
-gen_tunable(allow_gssd_read_tmp, false)
+gen_tunable(gssd_read_tmp, true)
 
 ## <desc>
-##	<p>
-##	Determine whether nfs can modify
-##	public files used for public file
-##	transfer services. Directories/Files must
-##	be labeled public_content_rw_t.
-##	</p>
+## <p>
+## Allow nfs servers to modify public files
+## used for public file transfer services.  Files/Directories must be
+## labeled public_content_rw_t.
+## </p>
 ## </desc>
-gen_tunable(allow_nfsd_anon_write, false)
+gen_tunable(nfsd_anon_write, false)
 
 attribute rpc_domain;
 
@@ -39,21 +37,23 @@ files_tmp_file(gssd_tmp_t)
 type rpcd_var_run_t;
 files_pid_file(rpcd_var_run_t)
 
+# rpcd_t is the domain of rpc daemons.
+# rpc_exec_t is the type of rpc daemon programs.
 rpc_domain_template(rpcd)
 
 type rpcd_initrc_exec_t;
 init_script_file(rpcd_initrc_exec_t)
 
+type rpcd_unit_file_t;
+systemd_unit_file(rpcd_unit_file_t)
+
 rpc_domain_template(nfsd)
 
 type nfsd_initrc_exec_t;
 init_script_file(nfsd_initrc_exec_t)
 
-type nfsd_rw_t;
-files_type(nfsd_rw_t)
-
-type nfsd_ro_t;
-files_type(nfsd_ro_t)
+type nfsd_unit_file_t;
+systemd_unit_file(nfsd_unit_file_t)
 
 type var_lib_nfs_t;
 files_mountpoint(var_lib_nfs_t)
@@ -71,7 +71,6 @@ allow rpc_domain self:tcp_socket { accep
 manage_dirs_pattern(rpc_domain, var_lib_nfs_t, var_lib_nfs_t)
 manage_files_pattern(rpc_domain, var_lib_nfs_t, var_lib_nfs_t)
 
-kernel_read_system_state(rpc_domain)
 kernel_read_kernel_sysctls(rpc_domain)
 kernel_rw_rpc_sysctls(rpc_domain)
 
@@ -79,8 +78,6 @@ dev_read_sysfs(rpc_domain)
 dev_read_urand(rpc_domain)
 dev_read_rand(rpc_domain)
 
-corenet_all_recvfrom_unlabeled(rpc_domain)
-corenet_all_recvfrom_netlabel(rpc_domain)
 corenet_tcp_sendrecv_generic_if(rpc_domain)
 corenet_udp_sendrecv_generic_if(rpc_domain)
 corenet_tcp_sendrecv_generic_node(rpc_domain)
@@ -108,41 +105,42 @@ files_read_etc_runtime_files(rpc_domain)
 files_read_usr_files(rpc_domain)
 files_list_home(rpc_domain)
 
-logging_send_syslog_msg(rpc_domain)
-
-miscfiles_read_localization(rpc_domain)
-
 userdom_dontaudit_use_unpriv_user_fds(rpc_domain)
 
 optional_policy(`
-	rpcbind_stream_connect(rpc_domain)
+    rpcbind_stream_connect(rpc_domain)
 ')
 
 optional_policy(`
-	seutil_sigchld_newrole(rpc_domain)
+    seutil_sigchld_newrole(rpc_domain)
 ')
 
 optional_policy(`
-	udev_read_db(rpc_domain)
+    udev_read_db(rpc_domain)
 ')
 
 ########################################
 #
-# Local policy
+# RPC local policy
 #
 
 allow rpcd_t self:capability { setpcap sys_admin chown dac_override setgid setuid };
 allow rpcd_t self:capability2 block_suspend;
+
 allow rpcd_t self:process { getcap setcap };
 allow rpcd_t self:fifo_file rw_fifo_file_perms;
 
+allow rpcd_t rpcd_var_run_t:dir setattr_dir_perms;
 manage_dirs_pattern(rpcd_t, rpcd_var_run_t, rpcd_var_run_t)
 manage_files_pattern(rpcd_t, rpcd_var_run_t, rpcd_var_run_t)
 files_pid_filetrans(rpcd_t, rpcd_var_run_t, { file dir })
 
+# rpc.statd executes sm-notify
 can_exec(rpcd_t, rpcd_exec_t)
 
+kernel_read_system_state(rpcd_t)
 kernel_read_network_state(rpcd_t)
+# for rpc.rquotad
 kernel_read_sysctl(rpcd_t)
 kernel_rw_fs_sysctls(rpcd_t)
 kernel_dontaudit_getattr_core_if(rpcd_t)
@@ -163,13 +161,14 @@ fs_getattr_all_fs(rpcd_t)
 
 storage_getattr_fixed_disk_dev(rpcd_t)
 
+init_read_utmp(rpcd_t)
+
 selinux_dontaudit_read_fs(rpcd_t)
 
 miscfiles_read_generic_certs(rpcd_t)
 
-seutil_dontaudit_search_config(rpcd_t)
-
-userdom_signal_all_users(rpcd_t)
+userdom_signal_unpriv_users(rpcd_t)
+userdom_read_user_home_content_files(rpcd_t)
 
 ifdef(`distro_debian',`
 	term_dontaudit_use_unallocated_ttys(rpcd_t)
@@ -181,19 +180,27 @@ optional_policy(`
 ')
 
 optional_policy(`
+	domain_unconfined_signal(rpcd_t)
+')
+
+optional_policy(`
+	quota_manage_db(rpcd_t)
+')
+
+optional_policy(`
 	nis_read_ypserv_config(rpcd_t)
 ')
 
 optional_policy(`
-	quota_manage_db_files(rpcd_t)
+	quota_read_db(rpcd_t)
 ')
 
 optional_policy(`
-	rgmanager_manage_tmp_files(rpcd_t)
+	rhcs_manage_cluster_tmp_files(rpcd_t)
 ')
 
 optional_policy(`
-	unconfined_signal(rpcd_t)
+    samba_stream_connect_nmbd(rpcd_t)
 ')
 
 ########################################
@@ -202,41 +209,56 @@ optional_policy(`
 #
 
 allow nfsd_t self:capability { dac_override dac_read_search sys_admin sys_resource };
+dontaudit nfsd_t self:capability sys_rawio;
 
 allow nfsd_t exports_t:file read_file_perms;
-allow nfsd_t { nfsd_rw_t nfsd_ro_t }:dir list_dir_perms;
 
+# for /proc/fs/nfs/exports - should we have a new type?
+kernel_read_system_state(nfsd_t)
 kernel_read_network_state(nfsd_t)
 kernel_dontaudit_getattr_core_if(nfsd_t)
-kernel_setsched(nfsd_t)
+kernel_dontaudit_setsched(nfsd_t)
 kernel_request_load_module(nfsd_t)
-# kernel_mounton_proc(nfsd_t)
+kernel_mounton_proc(nfsd_t)
+
+corecmd_exec_shell(nfsd_t)
 
-corenet_sendrecv_nfs_server_packets(nfsd_t)
+corenet_tcp_bind_all_rpc_ports(nfsd_t)
+corenet_udp_bind_all_rpc_ports(nfsd_t)
 corenet_tcp_bind_nfs_port(nfsd_t)
 corenet_udp_bind_nfs_port(nfsd_t)
-
-corecmd_exec_shell(nfsd_t)
+corenet_udp_bind_mountd_port(nfsd_t)
+corenet_tcp_bind_mountd_port(nfsd_t)
 
 dev_dontaudit_getattr_all_blk_files(nfsd_t)
 dev_dontaudit_getattr_all_chr_files(nfsd_t)
 dev_rw_lvm_control(nfsd_t)
 
+# does not really need this, but it is easier to just allow it
+files_search_pids(nfsd_t)
+# for exportfs and rpc.mountd
 files_getattr_tmp_dirs(nfsd_t)
+# cjp: this should really have its own type
 files_manage_mounttab(nfsd_t)
+files_read_etc_runtime_files(nfsd_t)
 
+fs_mounton_nfsd_fs(nfsd_t)
 fs_mount_nfsd_fs(nfsd_t)
 fs_getattr_all_fs(nfsd_t)
 fs_getattr_all_dirs(nfsd_t)
-fs_rw_nfsd_fs(nfsd_t)
-# fs_manage_nfsd_fs(nfsd_t)
+fs_manage_nfsd_fs(nfsd_t)
 
 storage_dontaudit_read_fixed_disk(nfsd_t)
 storage_raw_read_removable_device(nfsd_t)
 
+# Read access to public_content_t and public_content_rw_t
 miscfiles_read_public_files(nfsd_t)
 
-tunable_policy(`allow_nfsd_anon_write',`
+userdom_filetrans_home_content(nfsd_t)
+userdom_list_user_tmp(nfsd_t)
+
+# Write access to public_content_t and public_content_rw_t
+tunable_policy(`nfsd_anon_write',`
 	miscfiles_manage_public_files(nfsd_t)
 ')
 
@@ -245,7 +267,6 @@ tunable_policy(`nfs_export_all_rw',`
 	dev_getattr_all_chr_files(nfsd_t)
 
 	fs_read_noxattr_fs_files(nfsd_t)
-	files_manage_non_auth_files(nfsd_t)
 ')
 
 tunable_policy(`nfs_export_all_ro',`
@@ -257,12 +278,12 @@ tunable_policy(`nfs_export_all_ro',`
 
 	fs_read_noxattr_fs_files(nfsd_t)
 
-	files_list_non_auth_dirs(nfsd_t)
-	files_read_non_auth_files(nfsd_t)
+	files_read_non_security_files(nfsd_t)
 ')
 
 optional_policy(`
 	mount_exec(nfsd_t)
+	mount_manage_pid_files(nfsd_t)
 ')
 
 ########################################
@@ -270,7 +291,7 @@ optional_policy(`
 # GSSD local policy
 #
 
-allow gssd_t self:capability { dac_override dac_read_search setuid sys_nice };
+allow gssd_t self:capability { dac_override dac_read_search setuid setgid sys_nice };
 allow gssd_t self:process { getsched setsched };
 allow gssd_t self:fifo_file rw_fifo_file_perms;
 
@@ -280,6 +301,7 @@ manage_dirs_pattern(gssd_t, gssd_tmp_t,
 manage_files_pattern(gssd_t, gssd_tmp_t, gssd_tmp_t)
 files_tmp_filetrans(gssd_t, gssd_tmp_t, { file dir })
 
+kernel_read_system_state(gssd_t)
 kernel_read_network_state(gssd_t)
 kernel_read_network_state_symlinks(gssd_t)
 kernel_request_load_module(gssd_t)
@@ -288,25 +310,30 @@ kernel_signal(gssd_t)
 
 corecmd_exec_bin(gssd_t)
 
-fs_list_inotifyfs(gssd_t)
 fs_list_rpc(gssd_t)
 fs_rw_rpc_sockets(gssd_t)
 fs_read_rpc_files(gssd_t)
-fs_read_nfs_files(gssd_t)
+fs_read_nfsd_files(gssd_t)
 
+fs_list_inotifyfs(gssd_t)
 files_list_tmp(gssd_t)
+files_read_usr_symlinks(gssd_t)
 files_dontaudit_write_var_dirs(gssd_t)
 
+auth_use_nsswitch(gssd_t)
 auth_manage_cache(gssd_t)
 
 miscfiles_read_generic_certs(gssd_t)
 
 userdom_signal_all_users(gssd_t)
+userdom_manage_all_users_keys(gssd_t)
 
-tunable_policy(`allow_gssd_read_tmp',`
+tunable_policy(`gssd_read_tmp',`
 	userdom_list_user_tmp(gssd_t)
 	userdom_read_user_tmp_files(gssd_t)
 	userdom_read_user_tmp_symlinks(gssd_t)
+	userdom_manage_user_tmp_files(gssd_t)
+	files_read_generic_tmp_files(gssd_t)
 ')
 
 optional_policy(`
@@ -314,9 +341,12 @@ optional_policy(`
 ')
 
 optional_policy(`
+	gssproxy_stream_connect(gssd_t)
+')
+optional_policy(`
 	kerberos_manage_host_rcache(gssd_t)
 	kerberos_read_keytab(gssd_t)
-	kerberos_tmp_filetrans_host_rcache(gssd_t, file, "nfs_0")
+	kerberos_tmp_filetrans_host_rcache(gssd_t, "nfs_0")
 	kerberos_use(gssd_t)
 ')
 
